Attribute VB_Name = "mdlResize"
Option Explicit

'  -  
Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Sub CopyMemoryToMinMaxInfo Lib "Kernel32" Alias "RtlMoveMemory" (hpvDest As MINMAXINFO, ByVal hpvSource As Long, ByVal cbCopy As Long)
Private Declare Sub CopyMemoryFromMinMaxInfo Lib "Kernel32" Alias "RtlMoveMemory" (ByVal hpvDest As Long, hpvSource As MINMAXINFO, ByVal cbCopy As Long)
Private Type POINTAPI
    x As Long
    y As Long
End Type
Private Type MINMAXINFO
    ptReserved As POINTAPI
    ptMaxSize As POINTAPI
    ptMaxPosition As POINTAPI
    ptMinTrackSize As POINTAPI
    ptMaxTrackSize As POINTAPI
End Type
Private Type Resize
    xMin As Single
    yMin As Single
    xMax As Single
    yMax As Single
End Type

Private Const GWL_WNDPROC = -4
Private Const WM_GETMINMAXINFO = &H24
Private lpPrevWndProc As Long
Private gHW As Long
Private rResize As Resize

Public Sub Hook(ByVal wHWND As Long, Optional ByVal X_Min As Single = 0, Optional ByVal Y_Min As Single = 0, Optional ByVal X_Max As Single = 0, Optional ByVal Y_Max As Single = 0)
' 
gHW = wHWND ' ,      
rResize.xMax = X_Max
rResize.yMax = Y_Max
rResize.xMin = X_Min
rResize.yMin = Y_Min
lpPrevWndProc = SetWindowLong(gHW, GWL_WNDPROC, AddressOf WindowProc)
End Sub

Public Sub Unhook()
' 
Dim temp As Long
temp = SetWindowLong(gHW, GWL_WNDPROC, lpPrevWndProc)
End Sub

Private Function WindowProc(ByVal hw As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
',    
Dim MinMax As MINMAXINFO

If uMsg = WM_GETMINMAXINFO Then
    '   child MDI  (    )
    WindowProc = CallWindowProc(lpPrevWndProc, hw, uMsg, wParam, lParam)
    '      
    CopyMemoryToMinMaxInfo MinMax, lParam, Len(MinMax)

    '    
    '   -   MinMax.ptMinTrackSize.x(y), 
    '     .      
    If rResize.xMin <> 0 Then MinMax.ptMinTrackSize.x = rResize.xMin
    If rResize.yMin <> 0 Then MinMax.ptMinTrackSize.y = rResize.yMin

    '    
    If rResize.xMax <> 0 Then MinMax.ptMaxTrackSize.x = rResize.xMax
    If rResize.yMax <> 0 Then MinMax.ptMaxTrackSize.y = rResize.yMax

    '   
    CopyMemoryFromMinMaxInfo lParam, MinMax, Len(MinMax)

    WindowProc = DefWindowProc(hw, uMsg, wParam, lParam)
Else
    WindowProc = CallWindowProc(lpPrevWndProc, hw, uMsg, wParam, lParam)
End If
    
End Function

Public Sub Resize(ResFrm As Form, fHight As Integer, fWidth As Integer)
Dim i As Integer '  
On Error Resume Next
With ResFrm
    For i = 0 To .Controls.Count - 1
        DoEvents
        With .Controls(i)
            If Len(.Tag) = 8 And IsNumeric(.Tag) Then
                If Mid(.Tag, 1, 1) = 1 Then .Left = .Left + fWidth / val(Mid(.Tag, 5, 1))
                If Mid(.Tag, 2, 1) = 1 Then .Width = .Width + fWidth / val(Mid(.Tag, 6, 1))
                If Mid(.Tag, 3, 1) = 1 Then .Top = .Top + fHight / val(Mid(.Tag, 7, 1))
                If Mid(.Tag, 4, 1) = 1 Then .Height = .Height + fHight / val(Mid(.Tag, 8, 1))
                If Mid(.Tag, 1, 1) = 2 Then .x2 = .x2 + fWidth / val(Mid(.Tag, 5, 1))
            End If
        End With
    Next i
End With
End Sub
